#ifndef __CDF_h_
#define __CDF_h_
#include <adevs.h>
#include "IOtype.h"

class CDF: public atomic
{
	public:
		static const port_t flux;
		static const port_t soln_left;
		static const port_t soln_right;

		CDF();
		CDF(int x, vec ul, vec ur);
		CDF(const CDF& src);
		object* clone() const { return new CDF(*this); }
		const CDF& operator=(const CDF& src);
		void init();
		void delta_int();
		void delta_ext(stime_t e, const adevs_bag<PortValue>& x);
		void delta_conf(const adevs_bag<PortValue>& x);
		void output_func(adevs_bag<PortValue>& y);
		void gc_output(adevs_bag<PortValue>& y){}
		~CDF(){}
		int getIndex() const { return index; }
	private:
		vec ul, ur, f;
		int index;
		void compute_flux();
};

#endif
