#ifndef __genr_h_
#define __genr_h_
#include <adevs.h>
#include "cell.h"

/**
An entity generator.  Creates entities
with exponentially distributed creation time
and exponentially distributed service time.
*/
class genr: public atomic 
{
	public:
		static const port_t out;
		genr();
		genr(double creation_mean, double service_mean, long seed);
		genr(const genr& src);
		const genr& operator=(const genr& src);
		void init();
		void delta_int();
		void delta_ext(stime_t e, const adevs_bag<PortValue>& x){}
		void delta_conf(const adevs_bag<PortValue>& x){}
		void output_func(adevs_bag<PortValue>& y);
		void gc_output(adevs_bag<PortValue>& g);
		object* clone() const { return new genr(*this); }
		~genr(){}
	private:
		double mServiceMean;
		double mCreationMean;
		long mSeed; 
		rv r;
		double service_time;
	};

#endif
