#ifndef __perf__timer_h
#define __perf__timer_h
#include <sys/time.h>
#include <unistd.h>

static struct timeval _t_start;
static struct timeval _t_end;

static void tic()
{
	gettimeofday(&_t_start,NULL);
} 

/// Returns execution time in micro-seconds
static unsigned long toc()
{
	gettimeofday(&_t_end,NULL);
	unsigned long secs = (_t_end.tv_sec - _t_start.tv_sec)*1000000;
	unsigned long usecs = (_t_end.tv_usec-_t_start.tv_usec);
	if (_t_end.tv_usec < _t_start.tv_usec)
		usecs = (_t_start.tv_usec-_t_end.tv_usec);
	return secs+usecs;
}

/// Returns execution time in seconds
static double tocs()
{
	unsigned long e = toc();
	return (double)e*1E-6;
}

#endif
