/***************
adevs, a library supporting discrete event simulation
Copyright (C) 2002 James Nutaro

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Bugs, comments, and questions can be sent to nutaro@ece.arizona.edu
***************/
#include "broken_atexit.h"
#define MAX_FUNCS 1000

static void(*funcs[MAX_FUNCS])(void);
static int registered = 0;

void gprof_exit(int exit_code)
{
	for (int i = registered-1; i >= 0; i--)
		funcs[i]();
	exit(exit_code);
}

int atexit(void (*function)(void))
{
	funcs[registered] = function;
	registered++;
	if (registered >= MAX_FUNCS) return -1;
	else return 0;
}
