#include <adevs.h>
#include <iostream>
#include <algorithm>
#include "gcd.h"

int main() 
{
	try
	{
		std::cout << "Test 2x" << std::endl;
		gcd* c = new gcd(10.0,2.0,1,false);
		genr* g = new genr(10.0,1,true);
		xdevssim sim_c(c);
		xdevssim sim_g(g);
		sim_g.initialize();
		sim_c.initialize();
		while (sim_c.nextTN() < INFINITY || sim_g.nextTN() < INFINITY)
		{
			sim_c.computeInputOutput();
			sim_g.computeInputOutput();
			double tN = min(sim_c.nextTN(),sim_g.nextTN());
			if (sim_g.nextTN() == tN)
			{
				adevs_bag<PortValue> x(sim_g.computeInputOutput());
				for (int i = 0; i < x.getSize(); i++)
				{
					if (x[i].port == g->signal)
					{
						PortValue p(c->in,new object(*(x[i].value)));
						sim_c.inject(p);
					}
				}
			}
			sim_c.deltFunc(tN);
			sim_g.deltFunc(tN);
		}
		sim_c.finalize();
		sim_g.finalize();
		std::cout << "Test done" << std::endl;
	}
	catch(adevs_exception& err)
	{
		std::cout << err.getErrorMsg() << std::endl;
		assert(false);
	}
return 0;
}
