#include <adevs.h>
#include <iostream>
#include <assert.h>
#ifndef __node_h_
#define __node_h_

class node: public atomic 
{
	public:
		static const port_t in;
		static const port_t out;

		node(int ID,int holdtime,intg* token,bool no_output = false):
		atomic(),ID(ID),holdtime(holdtime),token(token) {}
		void init() 
		{
			out_token = token;
			if (token != NULL) 
				hold(holdtime);
			else 
				passivate();
		}
		void delta_int()
		{
			assert(token != NULL);
			std::cout<<ID<<" sent "<<out_token->value<<" @ t = "<<timeCurrent()<<std::endl;
			out_token = token;
			passivate();
		}
		void delta_ext(stime_t e, const adevs_bag<PortValue>& x)
		{
			assert (x.getSize() == 1);
			token = (intg*)(x.get(0).value);
			if (out_token == NULL) out_token = token;
			std::cout<<ID<<" got "<<token->value<<" @ t = "<<timeCurrent()<<std::endl;
			hold(holdtime);
		}
		void delta_conf(const adevs_bag<PortValue>& x) 
		{
			assert (x.getSize() == 1);
			std::cout<<ID<<" sent "<<token->value<<" @ t = "<<timeCurrent()<<std::endl;
			token = (intg*)(x.get(0).value);
			out_token = token;
			std::cout<<ID<<" got "<<token->value<<" @ t = "<<timeCurrent()<<std::endl;
			hold(holdtime);
		}
		void output_func(adevs_bag<PortValue>& y)
		{
			output(out,out_token,y);
		}
		void gc_output(adevs_bag<PortValue>& g){}

		~node(){}
	private:	
		int ID;
		stime_t holdtime;
		intg* token;
		intg* out_token;
};
		
const port_t node::in(0);
const port_t node::out(1);

#endif
